#
# spec file for package ghc-capataz
#
# Copyright (c) 2018 SUSE LINUX GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#


%global pkg_name capataz
%bcond_with tests
Name:           ghc-%{pkg_name}
Version:        0.1.0.1
Release:        4.4
Summary:        OTP-like supervision trees in Haskell
License:        MIT
Group:          Development/Libraries/Haskell
URL:            https://hackage.haskell.org/package/%{pkg_name}
Source0:        https://hackage.haskell.org/package/%{pkg_name}-%{version}/%{pkg_name}-%{version}.tar.gz
BuildRequires:  ghc-Cabal-devel
BuildRequires:  ghc-async-devel
BuildRequires:  ghc-bytestring-devel
BuildRequires:  ghc-data-default-devel
BuildRequires:  ghc-microlens-devel
BuildRequires:  ghc-protolude-devel
BuildRequires:  ghc-rpm-macros
BuildRequires:  ghc-safe-exceptions-devel
BuildRequires:  ghc-stm-devel
BuildRequires:  ghc-teardown-devel
BuildRequires:  ghc-text-devel
BuildRequires:  ghc-time-devel
BuildRequires:  ghc-unordered-containers-devel
BuildRequires:  ghc-uuid-devel
BuildRequires:  ghc-vector-devel
%if %{with tests}
BuildRequires:  ghc-pretty-show-devel
BuildRequires:  ghc-tasty-devel
BuildRequires:  ghc-tasty-hunit-devel
BuildRequires:  ghc-tasty-rerun-devel
BuildRequires:  ghc-tasty-smallcheck-devel
%endif

%description
`capataz` enhances the reliability of your concurrent applications by offering
supervision of green threads that run in your application.

Advantages over standard library:

* Links related long-living processes together under a common capataz
supervisor, with restart/shutdown order

* Set restart strategies (Permanent, Transient, Temporary) on `IO` sub-routines
on a granular level

* Set restart strategies on a pool of long-living worker threads (AllForOne,
OneForOne)

* Complete telemetry on the sub-routine lifecycle of your application (start,
error, restarts, shutdown).

%package devel
Summary:        Haskell %{pkg_name} library development files
Group:          Development/Libraries/Haskell
Requires:       %{name} = %{version}-%{release}
Requires:       ghc-compiler = %{ghc_version}
Requires(post): ghc-compiler = %{ghc_version}
Requires(postun): ghc-compiler = %{ghc_version}

%description devel
This package provides the Haskell %{pkg_name} library development files.

%prep
%setup -q -n %{pkg_name}-%{version}

%build
%ghc_lib_build

%install
%ghc_lib_install

%check
%cabal_test

%post devel
%ghc_pkg_recache

%postun devel
%ghc_pkg_recache

%files -f %{name}.files
%license LICENSE

%files devel -f %{name}-devel.files
%doc CHANGELOG.md README.md

%changelog
* Wed Mar 14 2018 psimons@suse.com
- Update capataz to version 0.1.0.1.
  A more detailed change log is not available.
